//
//  AppDelegate.m
//  irMagicianStatusBarApp
//
//  Created by ooo on 2014/04/01.
//  Copyright (c) 2014年 ooo. All rights reserved.
//

#import "AppDelegate.h"


@interface AppDelegate ()
@property (strong) IBOutlet NSMenu *irMagician;
@property (strong) IBOutlet NSMenuItem *irPlay;
@property (strong) IBOutlet NSMenuItem *irCap;

@property (strong) IBOutlet NSWindow *receiveDlgWindow;
@property (strong) IBOutlet NSTextField *receiveDlgWindowValue;
@property (strong) IBOutlet NSProgressIndicator *receiveDlgWindowProgressIndicator;

@property (strong) IBOutlet NSWindow *prefWindow;


@end

@implementation AppDelegate

@synthesize receiveDlgWindow;
@synthesize receiveDlgWindowValue;
@synthesize receiveDlgWindowProgressIndicator;

@synthesize prefWindow;


NSStatusItem *_statusItem;

- (id)init
{
    self = [super init];
    [[NSUserNotificationCenter defaultUserNotificationCenter] setDelegate:self];
    irDataArray = [[NSMutableArray alloc] init];
    irElementStr = [[NSMutableString alloc] initWithString:@""];
    
    return self;
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
    
    [receiveDlgWindow orderOut:aNotification];
    [prefWindow orderOut:aNotification];
    
    [self setupStatusItem];
}

- (void)applicationWillTerminate:(NSNotification *)notification
{
    [self.serialPort close];
    return;
}



- (void)setupStatusItem
{
    NSAlert *alert = [[NSAlert alloc] init];
    [alert addButtonWithTitle:@"OK"];
    [alert setMessageText:@"irMagician status"];
    [alert setAlertStyle:NSWarningAlertStyle];

//    self.serialPort = [ORSSerialPort serialPortWithPath:@"/dev/cu.usbmodem01231"];
    self.serialPort = [ORSSerialPort serialPortWithPath:@"/dev/cu.usbmodem1421"];
    
    if(self.serialPort == nil){
        [alert setInformativeText:@"Can't find irMagician !!"];
        if ([alert runModal] == NSAlertFirstButtonReturn) {
            // OK clicked.
        }
        exit(-1);
    }
    self.serialPort.baudRate = [NSNumber numberWithInteger:9600];
    self.serialPort.delegate = self;
    [self.serialPort open];
    
    
    statusIrMagician = 0;
    NSStatusBar *systemStatusBar = [NSStatusBar systemStatusBar];
    _statusItem = [systemStatusBar statusItemWithLength:NSVariableStatusItemLength];
    [_statusItem setHighlightMode:YES];
    [_statusItem setTitle:@""];
    [_statusItem setImage:[NSImage imageNamed:@"Image"]];
    [_statusItem setMenu:self.irMagician];

}

- (IBAction)Play:(id)sender
{
    NSData *dataToSend = [@"p\r\n" dataUsingEncoding:NSUTF8StringEncoding];
    [self.serialPort sendData:dataToSend];
}

- (IBAction)Cap:(id)sender
{
    NSData *dataToSend;
    
    dataToSend = [@"c\r\n" dataUsingEncoding:NSUTF8StringEncoding];
    [self.serialPort sendData:dataToSend];
    
    statusIrMagician = 1;
    
    // Dialog Box
    [receiveDlgWindowProgressIndicator setDoubleValue:0.0];
    [receiveDlgWindowProgressIndicator setMinValue:0.0];
    [receiveDlgWindowProgressIndicator setMaxValue:100.0];
    
    
    [receiveDlgWindow orderFront:sender];
    [receiveDlgWindowValue setStringValue:@""];
    
    
    int count;
    for ( count = 0; count < [receiveDlgWindowProgressIndicator maxValue]; count++ ) {
        [NSThread sleepForTimeInterval:2.0 / 100.0];
        [receiveDlgWindowProgressIndicator setDoubleValue:count];
    }
    [receiveDlgWindowProgressIndicator setDoubleValue:100.0];

    [receiveDlgWindow orderOut:sender];

}


- (IBAction)ReadIrMagician:(id)sender
{
    NSInteger n, bank, pos, recNumber;

    [irDataArray removeAllObjects];

    recNumber = irRecNumber;

    //Bank & Data setting
    for(n = 0;n < recNumber;n++){
        bank = n / 64;
        pos = n % 64;
        if (pos == 0){
            // Bank set
            [self irMagician_B_command:bank];
        }
        //Data read
        [self irMagician_D_command:pos];
        [NSThread sleepForTimeInterval:0.005];
    }
}

- (IBAction)saveIrData:(id)sender
{
    
    NSString *jsonStr;

    NSLog(@"Number of Array:%ld", [irDataArray count]);
    
    NSMutableDictionary *mdic = [[NSMutableDictionary alloc] init];
    mdic = [@{@"postscale":[NSNumber numberWithInt:100],
              @"freq":[NSNumber numberWithInt:38],
              @"format":@"raw",
              @"data":irDataArray}
            mutableCopy];
    
    if([NSJSONSerialization isValidJSONObject:mdic]){
        NSData *json = [NSJSONSerialization dataWithJSONObject:mdic options:NSJSONWritingPrettyPrinted error:nil];
        jsonStr = [[NSString alloc] initWithData:json encoding:NSUTF8StringEncoding];
        NSLog(@"%@", jsonStr);
    }

    
    //Path setting decision is here
    NSSavePanel *savePanel	= [NSSavePanel savePanel];
    NSArray *allowedFileTypes = [NSArray arrayWithObjects:@"json",@"'TEXT'",nil];

    // NSSavePanel interface has changed since Mac OSX v10.6.
    [savePanel setAllowedFileTypes:allowedFileTypes];
    NSInteger pressedButton = [savePanel runModal];
    
    if( pressedButton == NSOKButton ){
        
        // get file path (use NSURL)
        NSURL * filePath = [savePanel URL];
        NSString *filePathStr = [filePath path];
        
        // save file here
        NSLog(@"filepath saved '%@'", filePath);
        NSLog(@"filepathStr saved '%@'", filePathStr);

        // Wtite file with NSString
        [jsonStr writeToFile:filePathStr atomically:YES encoding:NSUTF8StringEncoding error:nil];
        
    }else if( pressedButton == NSCancelButton ){
     	NSLog(@"Cancel button was pressed.");
    }else{
     	// error
    }
}



- (void)serialPort:(ORSSerialPort *)serialPort didReceiveData:(NSData *)data
{
    NSAlert *alert = [[NSAlert alloc] init];
    [alert addButtonWithTitle:@"OK"];
    [alert setMessageText:@"irMagician status"];
    [alert setAlertStyle:NSWarningAlertStyle];
    
    NSString *string = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    NSInteger recNumber;
    unsigned int hexValue;
    
    NSLog(@"received:%@",string);

    switch (statusIrMagician) {
        case 0:
            break;

        case 1:
            if([string compare:@"..."] == NSOrderedSame){
                // OK
                statusIrMagician = 2;
            }
            else{
                // NG
                statusIrMagician = 0;
            }
            break;
            
        case 2:
            recNumber = [string integerValue];
            if([string compare:@" Time Out !\r\n" ] == NSOrderedSame){
                [alert setInformativeText:@"Time Out !!"];
                if ([alert runModal] == NSAlertFirstButtonReturn) {
                    // OK clicked.
                }
                NSLog(@"Time Out detected");
                statusIrMagician = 0;
            }
            if(recNumber > 30){
                NSString *validStr = [[NSString alloc] initWithFormat:@"Record Number --- %03ld points", recNumber];
                [alert setInformativeText:validStr];
                if ([alert runModal] == NSAlertFirstButtonReturn) {
                    // OK clicked.
                }
                NSLog(@"Rec number:%@", string);
                irRecNumber = recNumber;
                statusIrMagician = 3;
            }
            break;
            
        case 3:
            if([string length] < 3){
                NSLog(@"Data receive missed");

                switch(irElementCounter){
                    case 0:
                        [irElementStr setString:string];
                        irElementCounter++;
                        break;
                        
                    case 1:
                        [irElementStr appendString:string];
                        [[NSScanner scannerWithString:irElementStr] scanHexInt:&hexValue];
                        NSLog(@"Reading Data:%03ld 0x%02x %03d", [irDataArray count], hexValue, hexValue);
                        [irDataArray addObject:[NSNumber numberWithInt:hexValue]];
                        irElementCounter = 0;
                        break;
                        
                    default:
                        break;
                }
            }
            else{
                [[NSScanner scannerWithString:string] scanHexInt:&hexValue];
                NSLog(@"Reading Data:%03ld 0x%02x %03d", [irDataArray count], hexValue, hexValue);
                [irDataArray addObject:[NSNumber numberWithInt:hexValue]];
                if([irDataArray count] >= irRecNumber){
                    [alert setInformativeText:@"irData read from irMagician completed !!"];
                    if ([alert runModal] == NSAlertFirstButtonReturn) {
                        // OK clicked.
                    }
                }
            }
            break;
            
        default:
            break;
    }
}

- (void)serialPortWasRemovedFromSystem:(ORSSerialPort *)serialPort
{
    
}


- (void)serialPort:(ORSSerialPort *)serialPort didEncounterError:(NSError *)error
{
    NSAlert *alert = [[NSAlert alloc] init];
    [alert addButtonWithTitle:@"Exit"];
    [alert setMessageText:@"irMagician status"];
    [alert setAlertStyle:NSWarningAlertStyle];
    
    
    [alert setInformativeText:@"Error occurred"];
    if ([alert runModal] == NSAlertFirstButtonReturn) {
        // OK clicked.
        exit(-1);
    }
    return;
}



- (IBAction)homeTvPowerToggle:(id)sender
{
    //http://www.omiya-giken.com/irMagician/irData/Sharp/TV/PowerToggle.json
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/PowerToggle.json"];
}
- (IBAction)homeTvMute:(id)sender
{
    //
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Mute.json"];
}
- (IBAction)homeTvChUp:(id)sender
{
    //http://www.omiya-giken.com/irMagician/irData/Sharp/TV/ChUp.json
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/ChUp.json"];
}
- (IBAction)homeTvChDown:(id)sender
{
    //http://www.omiya-giken.com/irMagician/irData/Sharp/TV/ChDown.json
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/ChDown.json"];
}


- (IBAction)homeTvCh1:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch1.json"];
}
- (IBAction)homeTvCh2:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch2.json"];
}
- (IBAction)homeTvCh3:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch3.json"];
}
- (IBAction)homeTvCh4:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch4.json"];
}
- (IBAction)homeTvCh5:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch5.json"];
}
- (IBAction)homeTvCh6:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch6.json"];
}
- (IBAction)homeTvCh7:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch7.json"];
}
- (IBAction)homeTvCh8:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch8.json"];
}
- (IBAction)homeTvCh9:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch9.json"];
}
- (IBAction)homeTvCh10:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch10.json"];
}
- (IBAction)homeTvCh11:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch11.json"];
}
- (IBAction)homeTvCh12:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Sharp/TV/Ch12.json"];
}





- (IBAction)homeLightOn:(id)sender;
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Toshiba/CeilingLight/FRC-186T/Scene.json"];
}
- (IBAction)homeLightOff:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Toshiba/CeilingLight/FRC-186T/LightOff.json"];
}
- (IBAction)homeLightUp:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Toshiba/CeilingLight/FRC-186T/LightUp.json"];
}
- (IBAction)homeLightDown:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Toshiba/CeilingLight/FRC-186T/LightDown.json"];
}


- (IBAction)homeAirconOn:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/MHI/AirCon/RLA502A700/PowerOn_Cool-Wind_low-Direction_swing_Temp-27.json"];    
}

// http://www.omiya-giken.com/irMagician/irData/MHI/AirCon/RLA502A700/PowerOff.json
- (IBAction)homeAirconOff:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/MHI/AirCon/RLA502A700/PowerOff.json"];
}




- (IBAction)officeLightOn:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Panasonic/CeilingLight/HK9478/Scene.json"];
}

- (IBAction)officeLightOff:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Panasonic/CeilingLight/HK9478/LightOff.json"];
}

- (IBAction)officeAirconOn:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Melco/AirCon/NA0511/PowerOn_Cool-Wind_low-Direction_high_Temp-25.json"];
}

- (IBAction)officeAirconOff:(id)sender;
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/Melco/AirCon/NA0511/PowerOff.json"];
}

- (IBAction)testOnline:(id)sender
{
    [self sendIrData:@"http://www.omiya-giken.com/irMagician/irData/_test/test.json"];
}


- (IBAction)preferenceTest:(id)sender
{
    [prefWindow orderFront:sender];
}



- (void) sendIrData:(NSString*)aIrURL
{
    statusIrMagician = 0;

    NSURLRequest *irRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:aIrURL]];
    NSData *irJson = [NSURLConnection sendSynchronousRequest:irRequest returningResponse:nil error:nil];
    NSArray *irArray = [NSJSONSerialization JSONObjectWithData:irJson options:NSJSONReadingAllowFragments error:nil];
    
    NSLog(@"Post Scale: %@ Frequncey: %@KHz Data count: %ld", [irArray valueForKey:@"postscale"], [irArray valueForKey:@"freq"], [[irArray valueForKey:@"data"] count]);
    
    NSInteger recNumber = [[irArray valueForKey:@"data"]count];
    NSString *postScaler = [irArray valueForKey:@"postscale"];
    NSInteger n, bank, pos;
    NSString *dataString, *objectString;
    NSData *dataToSend;
    
    // Data length setting
    dataString = [NSString stringWithFormat:@"n,%ld\r\n", recNumber];
    dataToSend = [dataString dataUsingEncoding:NSUTF8StringEncoding];
    [self.serialPort sendData:dataToSend];
    [NSThread sleepForTimeInterval:0.1];
    
    //Post scale setting
    dataString = [NSString stringWithFormat:@"k,%@\r\n", postScaler];
    dataToSend = [dataString dataUsingEncoding:NSUTF8StringEncoding];
    [self.serialPort sendData:dataToSend];
    [NSThread sleepForTimeInterval:0.1];
    
    //Bank & Data setting
    for(n = 0;n < recNumber;n++){
        // Bank set
        bank = n / 64;
        pos = n % 64;
        if (pos == 0){
            [self irMagician_B_command:bank];
        }
        //Data set
        objectString = [[irArray valueForKey:@"data"]objectAtIndex:n];
        dataString = [NSString stringWithFormat:@"w,%ld,%@\r\n", pos, objectString];
        dataToSend = [dataString dataUsingEncoding:NSUTF8StringEncoding];
        [self.serialPort sendData:dataToSend];
        [NSThread sleepForTimeInterval:0.01];
    }
    
    // Play remcom data
    dataToSend = [@"p\r\n" dataUsingEncoding:NSUTF8StringEncoding];
    [self.serialPort sendData:dataToSend];

}

- (void) irMagician_B_command:(NSInteger)aBank
{
    NSString *dataString;
    NSData *dataToSend;
    
    dataString = [NSString stringWithFormat:@"b,%ld\r\n", aBank];
    dataToSend = [dataString dataUsingEncoding:NSUTF8StringEncoding];
    [self.serialPort sendData:dataToSend];
}

- (void) irMagician_D_command:(NSInteger)aPos
{
    NSString *dataString;
    NSData *dataToSend;
    
    dataString = [NSString stringWithFormat:@"d,%ld\r\n", aPos];
    dataToSend = [dataString dataUsingEncoding:NSUTF8StringEncoding];
    [self.serialPort sendData:dataToSend];
}


@end
